﻿//DESCRIPTION:Trim any characters that aren't numbers from the clipboard contents

// Modified 2023-04-10
// Keith Gilbert, Gilbert Consulting
// www.gilbertconsulting.com

Pre();
  
function Pre () {  
	if (!app.documents.length) { 
		alert("No InDesign documents are open. Please open a document and try again.");
		return;
	}  
	Main();
}  

function Main() {
	var myDoc = app.activeDocument;
	// Create a temporary layer and text frame to retrieve the clipboard contents
	var myTempLayer = myDoc.layers.add();
	var myTempTextFrame = myDoc.textFrames.add(myTempLayer);
	myTempTextFrame.insertionPoints[-1].select();
	app.paste();
	// Remove all non-numeric characters from the textframe contents (also retain the decimal point)
	var myString = myTempTextFrame.parentStory.contents;
	myString = myString.replace(/[^0-9.]/g, "");
	// Put the scrubbed text back on the clipboard
	myTempTextFrame.parentStory.contents = myString;
	app.select(myTempTextFrame.parentStory.texts[0]);
	app.copy();
	myTempLayer.remove();
}